Subject: bug#51819: [External] : bug#51819: The Senselessness of Emacs Company Mode

From: Drew Adams <[email-masked]>
Date: Wed, 17 Nov 2021 16:36:21 +0000

> > > I am very interested in completion of words as I write documents.
> >
> > Caveat: I'm not following this thread. I just
> > happened upon that sentence.
> 
> Mostly interested in completion mechanisms that do
> not require me to install packages, as I consider
> completion to be such a basic functionality that it
> should be installed by default, unless one decides
> excludes to exclude it.  More for new users,
> because I am mainly using company-mode.

As I said, `completion.el' is part of Emacs, and
has been for a very long time.  You don't need to
"install" it.  You don't even need to `require'
it.  Just turn on `dynamic-completion-mode'.

> > Wrt your expressed interest, I assume you already
> > know about `dabbrev'. You might also be interested
> > in the very old library` completion.el'. It's still
> > part of Emacs and still useful, precisely for what
> > you describe: completing words you actually use
> > when writing <whatever>.
> 
> There is also abbrev-mode.

So maybe you're not acquainted with `dabbrev'
after all.  The `d' is for `dynamic'.  It uses,
as its base for completion, words you've already
typed.

`abbrev-mode' works off of a set of explicitly
defined abbrevs.  Dynamic abbreviation works off of
words you yourself use, automatically.

https://www.gnu.org/software/emacs/manual/html_node/emacs/Dynamic-Abbrevs.html

> There is just too many versions and too many to
> try out.  That's my basic complaint.

Emacs is a world.  A world has a lot to explore.
Don't get intimidated or overwhelmed.

If you want to propose improvements to Emacs,
then it kinda behooves you to be somewhat
acquainted with what already exists - the thing
to be improved.

> The pop-up window is the most valuable for fast
> typers and writers.

Different people find different things to be faster
or more valuable.  I won't argue with you about
your preference.

And there are different kinds of "pop-up window",
and different means and triggers for popping up.
Those differences affect speed and convenience.

The set of completions popped up also affects
things: how many choices? what order? can you
change the number of choices? on the fly? can
you change the sort order? on the fly?

These things are not black & white ("_the_
most valuable").  There are advantages to
each possible combination, and different
people, in different use contexts, find
different choices to be most helpful/useful.

> > I'd say give it a try. You just might find
> > it useful.  `M-x find-library completion'.

Even easier: `M-x dynamic-completion-mode'.
But to see the description you need to consult
the library's Commentary text.